/*!
 * This class represents the retrieval of process information and populating
 * this information into an sqlite database.
 */

#ifndef PROCESSEXTRACTOR_H
#define PROCESSEXTRACTOR_H
#include <stdlib.h>
#include <signal.h>
#include <stdio.h>
#include <string.h>
#include <string>
#include <iostream>
#include <sqlite3.h>
#include <process.h>
#include <QtGui>


#define OPFILEPATH "/tmp/op_process_manager"
#define DBNAME "/tmp/temp_process_manager_db.db"
#define BUFFER 4096

class ProcessExtractor
{
private:
    sqlite3 *db;

    int executeProcess();
    int insertIntoDB(std::string);
    int connectToDB(int flag);
    void closeDB();

public:
    ProcessExtractor();
    ~ProcessExtractor();
    void addToDatabase();
    QList<Process> getList();

};

#endif // PROCESSEXTRACTOR_H
